﻿using System;
using System.Collections.Generic;
using TheGameExtreme.model.card;

namespace TheGameExtreme.model.deck
{
    public class ExtremeDeck : Deck
    {
        public ExtremeDeck()
        {
            Random random = new Random();
            List<int> endGame = new List<int>();
            while (endGame.Count < 4)
            {
                int r = random.Next(2, 99);
                if (!endGame.Contains(r))
                {
                    endGame.Add(r);
                }
            }
            List<int> threeCard = new List<int>();
            while (threeCard.Count < 4)
            {
                int r = random.Next(2, 99);
                if (!endGame.Contains(r) && !threeCard.Contains(r))
                {
                    threeCard.Add(r);
                }
            }
            Card card;
            for (int i = 2; i <= 99; i++)
            {
                if (endGame.Contains(i))
                {
                    card = new EndGameCard(i);
                }
                else if (threeCard.Contains(i))
                {
                    card = new ThreeCard(i);
                }
                else
                {
                    card = new ClassicCard(i);
                }
                deck.Add(card);
            }
        }
    }
}
